// Copyright 2023 Specter Ops, Inc.
//
// Licensed under the Apache License, Version 2.0
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// SPDX-License-Identifier: Apache-2.0

// Code generated by MockGen. DO NOT EDIT.
// Source: github.com/specterops/bloodhound/src/services/ingest (interfaces: IngestData)
//
// Generated by this command:
//
//	mockgen -copyright_file=../../../../../LICENSE.header -destination=./mocks/mock.go -package=mocks . IngestData
//

// Package mocks is a generated GoMock package.
package mocks

import (
	context "context"
	reflect "reflect"

	model "github.com/specterops/bloodhound/src/model"
	gomock "go.uber.org/mock/gomock"
)

// MockIngestData is a mock of IngestData interface.
type MockIngestData struct {
	ctrl     *gomock.Controller
	recorder *MockIngestDataMockRecorder
	isgomock struct{}
}

// MockIngestDataMockRecorder is the mock recorder for MockIngestData.
type MockIngestDataMockRecorder struct {
	mock *MockIngestData
}

// NewMockIngestData creates a new mock instance.
func NewMockIngestData(ctrl *gomock.Controller) *MockIngestData {
	mock := &MockIngestData{ctrl: ctrl}
	mock.recorder = &MockIngestDataMockRecorder{mock}
	return mock
}

// EXPECT returns an object that allows the caller to indicate expected use.
func (m *MockIngestData) EXPECT() *MockIngestDataMockRecorder {
	return m.recorder
}

// CancelAllIngestJobs mocks base method.
func (m *MockIngestData) CancelAllIngestJobs(ctx context.Context) error {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "CancelAllIngestJobs", ctx)
	ret0, _ := ret[0].(error)
	return ret0
}

// CancelAllIngestJobs indicates an expected call of CancelAllIngestJobs.
func (mr *MockIngestDataMockRecorder) CancelAllIngestJobs(ctx any) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "CancelAllIngestJobs", reflect.TypeOf((*MockIngestData)(nil).CancelAllIngestJobs), ctx)
}

// CreateCompositionInfo mocks base method.
func (m *MockIngestData) CreateCompositionInfo(ctx context.Context, nodes model.EdgeCompositionNodes, edges model.EdgeCompositionEdges) (model.EdgeCompositionNodes, model.EdgeCompositionEdges, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "CreateCompositionInfo", ctx, nodes, edges)
	ret0, _ := ret[0].(model.EdgeCompositionNodes)
	ret1, _ := ret[1].(model.EdgeCompositionEdges)
	ret2, _ := ret[2].(error)
	return ret0, ret1, ret2
}

// CreateCompositionInfo indicates an expected call of CreateCompositionInfo.
func (mr *MockIngestDataMockRecorder) CreateCompositionInfo(ctx, nodes, edges any) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "CreateCompositionInfo", reflect.TypeOf((*MockIngestData)(nil).CreateCompositionInfo), ctx, nodes, edges)
}

// CreateIngestJob mocks base method.
func (m *MockIngestData) CreateIngestJob(ctx context.Context, job model.IngestJob) (model.IngestJob, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "CreateIngestJob", ctx, job)
	ret0, _ := ret[0].(model.IngestJob)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// CreateIngestJob indicates an expected call of CreateIngestJob.
func (mr *MockIngestDataMockRecorder) CreateIngestJob(ctx, job any) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "CreateIngestJob", reflect.TypeOf((*MockIngestData)(nil).CreateIngestJob), ctx, job)
}

// CreateIngestTask mocks base method.
func (m *MockIngestData) CreateIngestTask(ctx context.Context, task model.IngestTask) (model.IngestTask, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "CreateIngestTask", ctx, task)
	ret0, _ := ret[0].(model.IngestTask)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// CreateIngestTask indicates an expected call of CreateIngestTask.
func (mr *MockIngestDataMockRecorder) CreateIngestTask(ctx, task any) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "CreateIngestTask", reflect.TypeOf((*MockIngestData)(nil).CreateIngestTask), ctx, task)
}

// DeleteAllIngestJobs mocks base method.
func (m *MockIngestData) DeleteAllIngestJobs(ctx context.Context) error {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "DeleteAllIngestJobs", ctx)
	ret0, _ := ret[0].(error)
	return ret0
}

// DeleteAllIngestJobs indicates an expected call of DeleteAllIngestJobs.
func (mr *MockIngestDataMockRecorder) DeleteAllIngestJobs(ctx any) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "DeleteAllIngestJobs", reflect.TypeOf((*MockIngestData)(nil).DeleteAllIngestJobs), ctx)
}

// DeleteAllIngestTasks mocks base method.
func (m *MockIngestData) DeleteAllIngestTasks(ctx context.Context) error {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "DeleteAllIngestTasks", ctx)
	ret0, _ := ret[0].(error)
	return ret0
}

// DeleteAllIngestTasks indicates an expected call of DeleteAllIngestTasks.
func (mr *MockIngestDataMockRecorder) DeleteAllIngestTasks(ctx any) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "DeleteAllIngestTasks", reflect.TypeOf((*MockIngestData)(nil).DeleteAllIngestTasks), ctx)
}

// GetAllIngestJobs mocks base method.
func (m *MockIngestData) GetAllIngestJobs(ctx context.Context, skip, limit int, order string, filter model.SQLFilter) ([]model.IngestJob, int, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "GetAllIngestJobs", ctx, skip, limit, order, filter)
	ret0, _ := ret[0].([]model.IngestJob)
	ret1, _ := ret[1].(int)
	ret2, _ := ret[2].(error)
	return ret0, ret1, ret2
}

// GetAllIngestJobs indicates an expected call of GetAllIngestJobs.
func (mr *MockIngestDataMockRecorder) GetAllIngestJobs(ctx, skip, limit, order, filter any) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "GetAllIngestJobs", reflect.TypeOf((*MockIngestData)(nil).GetAllIngestJobs), ctx, skip, limit, order, filter)
}

// GetIngestJob mocks base method.
func (m *MockIngestData) GetIngestJob(ctx context.Context, id int64) (model.IngestJob, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "GetIngestJob", ctx, id)
	ret0, _ := ret[0].(model.IngestJob)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// GetIngestJob indicates an expected call of GetIngestJob.
func (mr *MockIngestDataMockRecorder) GetIngestJob(ctx, id any) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "GetIngestJob", reflect.TypeOf((*MockIngestData)(nil).GetIngestJob), ctx, id)
}

// GetIngestJobsWithStatus mocks base method.
func (m *MockIngestData) GetIngestJobsWithStatus(ctx context.Context, status model.JobStatus) ([]model.IngestJob, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "GetIngestJobsWithStatus", ctx, status)
	ret0, _ := ret[0].([]model.IngestJob)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// GetIngestJobsWithStatus indicates an expected call of GetIngestJobsWithStatus.
func (mr *MockIngestDataMockRecorder) GetIngestJobsWithStatus(ctx, status any) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "GetIngestJobsWithStatus", reflect.TypeOf((*MockIngestData)(nil).GetIngestJobsWithStatus), ctx, status)
}

// UpdateIngestJob mocks base method.
func (m *MockIngestData) UpdateIngestJob(ctx context.Context, job model.IngestJob) error {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "UpdateIngestJob", ctx, job)
	ret0, _ := ret[0].(error)
	return ret0
}

// UpdateIngestJob indicates an expected call of UpdateIngestJob.
func (mr *MockIngestDataMockRecorder) UpdateIngestJob(ctx, job any) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "UpdateIngestJob", reflect.TypeOf((*MockIngestData)(nil).UpdateIngestJob), ctx, job)
}
